#!/usr/bin/python

import sys
import string

def check_md5_md5(md5name, checksum):
    try:
        md5file = open(md5name, 'r')
    except:
        return 0
    line = md5file.readline()
    if line[0:32] == checksum:
        ret = 1
    else:
        ret = -1
    md5file.close()
    return ret

def check_nfo_md5(nfoname, checksum):
    try:
        nfofile = open(nfoname, 'r')
    except:
        return 0

    while 1:
        line = nfofile.readline()
        if (len(line) == 0):
            break
        line = string.lower(line)
        pos = string.find(line, 'md5')
        if (pos < 0):
            continue
        #print line
        pos = pos + 3
        startpos = pos
        n = 0
        while pos < len(line):
            if line[pos] in string.hexdigits:
                n = n + 1
                if n == 32:
                    testcheck = line[pos-31:pos+1]
                    if checksum == testcheck:
                        ret = 1
                    else:
                        ret = -1
                    nfofile.close()
                    return ret
            else:
                n = 0
            pos = pos + 1
    nfofile.close()
    return 0

while 1:
    line = sys.stdin.readline()
    if len(line) == 0:
        break
    if (line[-1] == '\n'):
        line = line[0:len(line)-1]
    checksum = line[0:32]
    for i in range(32, len(line)):
        if line[i] not in string.whitespace:
            break
    if i == (len(line) - 1):
        print "illegal line:", line
        break
    filename = line[i:]
    if len(filename) < 4:
        continue

    dot_index = string.rfind(filename, '.')
    if dot_index < 0:
        continue

    postfix = filename[dot_index:]

    if postfix not in ['.nfo', '.md5']:
        l = len(postfix);
        nfoname = filename[0:len(filename) - l] + '.nfo'
        ret = check_nfo_md5(nfoname, checksum)
        if ret > 0:
            sys.stdout.write('OK:  ' + filename + '\n')
        elif ret < 0:
            sys.stdout.write('BAD: ' + filename + '\n')
        else:
            md5name = filename[0:len(filename) - l] + '.md5'
            ret = check_md5_md5(md5name, checksum)
            if ret > 0:
                sys.stdout.write('OK:  ' + filename + '\n')
            elif ret < 0:
                sys.stdout.write('BAD: ' + filename + '\n')
            else:
                sys.stdout.write('checksum not found: ' + filename + '\n')
        sys.stdout.flush()
