#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>

#include "md5.h"

extern int errno;

int main(int argc, char **argv)
{
  MD5_CTX c;
  int i, ret;
  unsigned char buf[4096];
  char md5sum[33];
  char *fname;
  struct stat st;
  int fd_in;

  for (i = 1; i < argc; i++) {
    fname = argv[i];
    fd_in = open(fname, O_RDONLY);
    
    if (fd_in < 0) {
      fprintf(stderr, "%s: %s: No such file\n", argv[0], fname);
      continue;
    }
    
    if (fstat(fd_in, &st)) {
      continue;
    }
    
    if (!S_ISREG(st.st_mode)) {
      fprintf(stderr, "%s: %s is not a regular file\n", argv[0], fname);
      continue;
    }

    MD5Init(&c);

    while (1) {
      ret = read(fd_in, buf, sizeof(buf));
      if (ret < 0) {
	if (errno != EINTR) {
	  perror("md5test read error");
	  break;
	}
	continue;
      } else if (ret == 0) {
	break;
      }
      MD5Update(&c, buf, ret);
    }

    close(fd_in);

    MD5Final((unsigned char *) buf, &c);

    sprintf(md5sum,
	    "%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x%.2x",
	    buf[0], buf[1], buf[2], buf[3], buf[4], buf[5], buf[6],
	    buf[7], buf[8], buf[9], buf[10], buf[11], buf[12], buf[13],
	    buf[14], buf[15]);

    printf("%s  %s\n", md5sum, fname);

    fflush(stdout);
  }
  return 0;
}
